/*******************************************************************
 Copyright (C) 2004 Thomas Kunz, CRC Canada, BCAST for IPv4.
 DISTRIBUTED WITH NO WARRANTY, EXPRESS OR IMPLIED.
 See the GNU Library General Public License (file COPYING in the
 distribution) for conditions of use and redistribution.
*********************************************************************/

/*
 * Common protocol header for BCAST
 */

#ifndef _bcast_h_

#define _bcast_h_

#include <netinet/in.h>

struct bcastHeader {
  u_int16_t 	type;
  in_addr_t 	sender_addr;
  u_int32_t	sequence_no;
  in_addr_t 	prev_hop;
};

// The following three message types are supported:

#define BCAST_DATA_PACKET	1
#define BCAST_HELLO_MSG		2
#define BCAST_NACK			3

#define BCAST_INTERFACE "ath0"

#define NIPQUAD(addr)   ((unsigned char *)&addr)[0], \
				((unsigned char *)&addr)[1], \
                        ((unsigned char *)&addr)[2], \
                        ((unsigned char *)&addr)[3]

#endif
