fea_common_get_target_name()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_common_get_target_name"
        exit 1
    fi

    XRL="finder://fea/common/0.1/get_target_name"
    call_xrl_wrapper -p all "${XRL}"
}

fea_common_get_version()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_common_get_version"
        exit 1
    fi

    XRL="finder://fea/common/0.1/get_version"
    call_xrl_wrapper -p all "${XRL}"
}

fea_common_get_status()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_common_get_status"
        exit 1
    fi

    XRL="finder://fea/common/0.1/get_status"
    call_xrl_wrapper -p all "${XRL}"
}

fea_common_shutdown()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_common_shutdown"
        exit 1
    fi

    XRL="finder://fea/common/0.1/shutdown"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_interface_names()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_ifmgr_get_configured_interface_names"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_interface_names"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_vif_names()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_configured_vif_names <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_vif_names?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_vif_flags()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_configured_vif_flags <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_vif_flags?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_vif_pif_index()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_configured_vif_pif_index <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_vif_pif_index?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_vif_addresses4()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_configured_vif_addresses4 <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_vif_addresses4?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_vif_addresses6()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_configured_vif_addresses6 <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_vif_addresses6?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_address_flags4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_address_flags4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_address_flags4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_address_flags6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_address_flags6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_address_flags6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_interface_enabled()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_configured_interface_enabled <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_interface_enabled?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_mac()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_configured_mac <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_mac?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_mtu()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_configured_mtu <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_mtu?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_vif_enabled()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_configured_vif_enabled <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_vif_enabled?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_prefix4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_prefix4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_prefix4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_broadcast4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_broadcast4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_broadcast4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_endpoint4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_endpoint4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_endpoint4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_prefix6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_prefix6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_prefix6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_endpoint6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_endpoint6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_endpoint6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_start_transaction()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_ifmgr_start_transaction"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/start_transaction"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_commit_transaction()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_commit_transaction <tid:u32>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/commit_transaction?tid:u32=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_abort_transaction()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_abort_transaction <tid:u32>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/abort_transaction?tid:u32=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_create_interface()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_create_interface <tid:u32> <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/create_interface?tid:u32=$1&ifname:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_delete_interface()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_delete_interface <tid:u32> <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/delete_interface?tid:u32=$1&ifname:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_interface_enabled()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_set_interface_enabled <tid:u32> <ifname:txt> <enabled:bool>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_interface_enabled?tid:u32=$1&ifname:txt=$2&enabled:bool=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_mac()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_set_mac <tid:u32> <ifname:txt> <mac:mac>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_mac?tid:u32=$1&ifname:txt=$2&mac:mac=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_mtu()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_set_mtu <tid:u32> <ifname:txt> <mtu:u32>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_mtu?tid:u32=$1&ifname:txt=$2&mtu:u32=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_create_vif()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_create_vif <tid:u32> <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/create_vif?tid:u32=$1&ifname:txt=$2&vif:txt=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_delete_vif()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_delete_vif <tid:u32> <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/delete_vif?tid:u32=$1&ifname:txt=$2&vif:txt=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_vif_enabled()
{
    if [ $# -ne 4 ] ; then
        echo "Usage: fea_ifmgr_set_vif_enabled <tid:u32> <ifname:txt> <vif:txt> <enabled:bool>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_vif_enabled?tid:u32=$1&ifname:txt=$2&vif:txt=$3&enabled:bool=$4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_create_address4()
{
    if [ $# -ne 4 ] ; then
        echo "Usage: fea_ifmgr_create_address4 <tid:u32> <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/create_address4?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv4=$4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_delete_address4()
{
    if [ $# -ne 4 ] ; then
        echo "Usage: fea_ifmgr_delete_address4 <tid:u32> <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/delete_address4?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv4=$4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_address_enabled4()
{
    if [ $# -ne 5 ] ; then
        echo "Usage: fea_ifmgr_set_address_enabled4 <tid:u32> <ifname:txt> <vif:txt> <address:ipv4> <enabled:bool>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_address_enabled4?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv4=$4&enabled:bool=$5"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_address_enabled4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_address_enabled4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_address_enabled4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_prefix4()
{
    if [ $# -ne 5 ] ; then
        echo "Usage: fea_ifmgr_set_prefix4 <tid:u32> <ifname:txt> <vif:txt> <address:ipv4> <prefix_len:u32>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_prefix4?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv4=$4&prefix_len:u32=$5"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_broadcast4()
{
    if [ $# -ne 5 ] ; then
        echo "Usage: fea_ifmgr_set_broadcast4 <tid:u32> <ifname:txt> <vif:txt> <address:ipv4> <broadcast:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_broadcast4?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv4=$4&broadcast:ipv4=$5"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_endpoint4()
{
    if [ $# -ne 5 ] ; then
        echo "Usage: fea_ifmgr_set_endpoint4 <tid:u32> <ifname:txt> <vif:txt> <address:ipv4> <endpoint:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_endpoint4?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv4=$4&endpoint:ipv4=$5"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_create_address6()
{
    if [ $# -ne 4 ] ; then
        echo "Usage: fea_ifmgr_create_address6 <tid:u32> <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/create_address6?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv6=$4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_delete_address6()
{
    if [ $# -ne 4 ] ; then
        echo "Usage: fea_ifmgr_delete_address6 <tid:u32> <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/delete_address6?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv6=$4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_address_enabled6()
{
    if [ $# -ne 5 ] ; then
        echo "Usage: fea_ifmgr_set_address_enabled6 <tid:u32> <ifname:txt> <vif:txt> <address:ipv6> <enabled:bool>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_address_enabled6?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv6=$4&enabled:bool=$5"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_configured_address_enabled6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_configured_address_enabled6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_configured_address_enabled6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_prefix6()
{
    if [ $# -ne 5 ] ; then
        echo "Usage: fea_ifmgr_set_prefix6 <tid:u32> <ifname:txt> <vif:txt> <address:ipv6> <prefix_len:u32>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_prefix6?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv6=$4&prefix_len:u32=$5"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_set_endpoint6()
{
    if [ $# -ne 5 ] ; then
        echo "Usage: fea_ifmgr_set_endpoint6 <tid:u32> <ifname:txt> <vif:txt> <address:ipv6> <endpoint:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/set_endpoint6?tid:u32=$1&ifname:txt=$2&vif:txt=$3&address:ipv6=$4&endpoint:ipv6=$5"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_register_client()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_register_client <clientname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/register_client?clientname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_unregister_client()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_unregister_client <clientname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/unregister_client?clientname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_interface_names()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_ifmgr_get_system_interface_names"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_interface_names"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_vif_names()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_system_vif_names <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_vif_names?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_vif_flags()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_system_vif_flags <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_vif_flags?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_vif_pif_index()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_system_vif_pif_index <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_vif_pif_index?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_vif_addresses4()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_system_vif_addresses4 <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_vif_addresses4?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_address_flags4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_address_flags4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_address_flags4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_vif_addresses6()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_system_vif_addresses6 <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_vif_addresses6?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_address_flags6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_address_flags6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_address_flags6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_interface_enabled()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_system_interface_enabled <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_interface_enabled?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_mac()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_system_mac <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_mac?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_mtu()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_get_system_mtu <ifname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_mtu?ifname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_vif_enabled()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_ifmgr_get_system_vif_enabled <ifname:txt> <vif:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_vif_enabled?ifname:txt=$1&vif:txt=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_prefix4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_prefix4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_prefix4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_broadcast4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_broadcast4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_broadcast4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_endpoint4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_endpoint4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_endpoint4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_prefix6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_prefix6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_prefix6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_endpoint6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_endpoint6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_endpoint6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_address_enabled4()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_address_enabled4 <ifname:txt> <vif:txt> <address:ipv4>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_address_enabled4?ifname:txt=$1&vif:txt=$2&address:ipv4=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_get_system_address_enabled6()
{
    if [ $# -ne 3 ] ; then
        echo "Usage: fea_ifmgr_get_system_address_enabled6 <ifname:txt> <vif:txt> <address:ipv6>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/get_system_address_enabled6?ifname:txt=$1&vif:txt=$2&address:ipv6=$3"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_register_system_interfaces_client()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_register_system_interfaces_client <clientname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/register_system_interfaces_client?clientname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_unregister_system_interfaces_client()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_unregister_system_interfaces_client <clientname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr/0.1/unregister_system_interfaces_client?clientname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_replicator_register_ifmgr_mirror()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_replicator_register_ifmgr_mirror <clientname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr_replicator/0.1/register_ifmgr_mirror?clientname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_ifmgr_replicator_unregister_ifmgr_mirror()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_ifmgr_replicator_unregister_ifmgr_mirror <clientname:txt>"
        exit 1
    fi

    XRL="finder://fea/ifmgr_replicator/0.1/unregister_ifmgr_mirror?clientname:txt=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_start_transaction()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_fti_start_transaction"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/start_transaction"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_commit_transaction()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_commit_transaction <tid:u32>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/commit_transaction?tid:u32=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_abort_transaction()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_abort_transaction <tid:u32>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/abort_transaction?tid:u32=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_add_entry4()
{
    if [ $# -ne 8 ] ; then
        echo "Usage: fea_fti_add_entry4 <tid:u32> <dst:ipv4net> <gateway:ipv4> <ifname:txt> <vifname:txt> <metric:u32> <admin_distance:u32> <protocol_origin:txt>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/add_entry4?tid:u32=$1&dst:ipv4net=$2&gateway:ipv4=$3&ifname:txt=$4&vifname:txt=$5&metric:u32=$6&admin_distance:u32=$7&protocol_origin:txt=$8"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_add_entry6()
{
    if [ $# -ne 8 ] ; then
        echo "Usage: fea_fti_add_entry6 <tid:u32> <dst:ipv6net> <gateway:ipv6> <ifname:txt> <vifname:txt> <metric:u32> <admin_distance:u32> <protocol_origin:txt>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/add_entry6?tid:u32=$1&dst:ipv6net=$2&gateway:ipv6=$3&ifname:txt=$4&vifname:txt=$5&metric:u32=$6&admin_distance:u32=$7&protocol_origin:txt=$8"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_delete_entry4()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_fti_delete_entry4 <tid:u32> <dst:ipv4net>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/delete_entry4?tid:u32=$1&dst:ipv4net=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_delete_entry6()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_fti_delete_entry6 <tid:u32> <dst:ipv6net>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/delete_entry6?tid:u32=$1&dst:ipv6net=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_delete_all_entries()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_delete_all_entries <tid:u32>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/delete_all_entries?tid:u32=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_delete_all_entries4()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_delete_all_entries4 <tid:u32>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/delete_all_entries4?tid:u32=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_delete_all_entries6()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_delete_all_entries6 <tid:u32>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/delete_all_entries6?tid:u32=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_lookup_route4()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_lookup_route4 <dst:ipv4>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/lookup_route4?dst:ipv4=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_lookup_route6()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_lookup_route6 <dst:ipv6>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/lookup_route6?dst:ipv6=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_lookup_entry4()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_lookup_entry4 <dst:ipv4net>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/lookup_entry4?dst:ipv4net=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_lookup_entry6()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_lookup_entry6 <dst:ipv6net>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/lookup_entry6?dst:ipv6net=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_have_ipv4()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_fti_have_ipv4"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/have_ipv4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_have_ipv6()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_fti_have_ipv6"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/have_ipv6"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_get_unicast_forwarding_enabled4()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_fti_get_unicast_forwarding_enabled4"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/get_unicast_forwarding_enabled4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_get_unicast_forwarding_enabled6()
{
    if [ $# -ne 0 ] ; then
        echo "Usage: fea_fti_get_unicast_forwarding_enabled6"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/get_unicast_forwarding_enabled6"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_set_unicast_forwarding_enabled4()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_set_unicast_forwarding_enabled4 <enabled:bool>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/set_unicast_forwarding_enabled4?enabled:bool=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_fti_set_unicast_forwarding_enabled6()
{
    if [ $# -ne 1 ] ; then
        echo "Usage: fea_fti_set_unicast_forwarding_enabled6 <enabled:bool>"
        exit 1
    fi

    XRL="finder://fea/fti/0.2/set_unicast_forwarding_enabled6?enabled:bool=$1"
    call_xrl_wrapper -p all "${XRL}"
}

fea_raw_packet_send4()
{
    if [ $# -ne 8 ] ; then
        echo "Usage: fea_raw_packet_send4 <src_address:ipv4> <dst_address:ipv4> <vif_name:txt> <proto:u32> <ttl:u32> <tos:u32> <options:binary> <payload:binary>"
        exit 1
    fi

    XRL="finder://fea/raw_packet/0.1/send4?src_address:ipv4=$1&dst_address:ipv4=$2&vif_name:txt=$3&proto:u32=$4&ttl:u32=$5&tos:u32=$6&options:binary=$7&payload:binary=$8"
    call_xrl_wrapper -p all "${XRL}"
}

fea_raw_packet_send_raw4()
{
    if [ $# -ne 2 ] ; then
        echo "Usage: fea_raw_packet_send_raw4 <vif_name:txt> <packet:binary>"
        exit 1
    fi

    XRL="finder://fea/raw_packet/0.1/send_raw4?vif_name:txt=$1&packet:binary=$2"
    call_xrl_wrapper -p all "${XRL}"
}

fea_raw_packet_register_vif_receiver()
{
    if [ $# -ne 4 ] ; then
        echo "Usage: fea_raw_packet_register_vif_receiver <router_name:txt> <if_name:txt> <vif_name:txt> <proto:u32>"
        exit 1
    fi

    XRL="finder://fea/raw_packet/0.1/register_vif_receiver?router_name:txt=$1&if_name:txt=$2&vif_name:txt=$3&proto:u32=$4"
    call_xrl_wrapper -p all "${XRL}"
}

fea_raw_packet_unregister_vif_receiver()
{
    if [ $# -ne 4 ] ; then
        echo "Usage: fea_raw_packet_unregister_vif_receiver <router_name:txt> <if_name:txt> <vif_name:txt> <proto:u32>"
        exit 1
    fi

    XRL="finder://fea/raw_packet/0.1/unregister_vif_receiver?router_name:txt=$1&if_name:txt=$2&vif_name:txt=$3&proto:u32=$4"
    call_xrl_wrapper -p all "${XRL}"
}

