/*******************************************************************
 Copyright (C) 2004 Thomas Kunz, CRC Canada, BCAST for IPv4.
 DISTRIBUTED WITH NO WARRANTY, EXPRESS OR IMPLIED.
 See the GNU Library General Public License (file COPYING in
 directory application) for conditions of use and redistribution.
*********************************************************************/

// -*- c-basic-offset: 4; tab-width: 8; indent-tabs-mode: t -*-

// Copyright (c) 2001-2003 International Computer Science Institute
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software")
// to deal in the Software without restriction, subject to the conditions
// listed in the XORP LICENSE file. These conditions include: you must
// preserve this copyright notice, and you cannot mention the copyright
// holders in advertising related to the Software without their permission.
// The Software is provided WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED. This
// notice is a summary of the XORP LICENSE file; the license in that file is
// legally binding.

#include "bcast_module.h"

#include <string>

#include "libxipc/xrl_router.hh"
#include "xrl/targets/bcast_base.hh"

class XrlBcastTarget: public XrlBcastTargetBase {
public:
    XrlBcastTarget(XrlRouter* r) : XrlBcastTargetBase(r) {}

protected:
    // Methods to be implemented by derived classes supporting this interface.
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values, 
	string&	name);

    virtual XrlCmdError common_0_1_get_version(
	// Output values, 
	string&	version);

    virtual XrlCmdError common_0_1_get_status(
	// Output values,
        uint32_t& status,
	string&	reason);

    virtual XrlCmdError common_0_1_shutdown();

    virtual XrlCmdError bcast_1_0_set_hello_interval(
	// Input values, 
	const int32_t&	new_int);

    virtual XrlCmdError bcast_1_0_get_hello_interval(
	// Output values, 
	int32_t&	old_int);

    virtual XrlCmdError bcast_1_0_set_buffer_size(
	// Input values, 
	const int32_t&	new_buf);

    virtual XrlCmdError bcast_1_0_get_buffer_size(
	// Output values, 
	int32_t&	old_buf);

    virtual XrlCmdError bcast_1_0_set_reliability(
	// Input values, 
	const bool&	reliability);

    virtual XrlCmdError bcast_1_0_get_reliability(
	// Output values, 
	bool&	reliability);

    virtual XrlCmdError bcast_1_0_set_interface(
	// Input values, 
	const string&	intf);

    virtual XrlCmdError bcast_1_0_get_interface(
	// Output values, 
	string&	intf);

    virtual XrlCmdError bcast_1_0_activate_bcast();

private:
    static int hello_interval;
    static int buffer_size;
    static bool reliability_level;
    static string interface;
};
