/*
 * Copyright (c) 2001-2003 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'clnt-gen'.
 *
 * $XORP$
 */

#ifndef __XRL_INTERFACES_BCAST_XIF_HH__
#define __XRL_INTERFACES_BCAST_XIF_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XifBcast"

#include "libxorp/xlog.h"
#include "libxorp/callback.hh"

#include "libxipc/xrl.hh"
#include "libxipc/xrl_error.hh"
#include "libxipc/xrl_sender.hh"


class XrlBcastV1p0Client {
public:
    XrlBcastV1p0Client(XrlSender* s) : _sender(s) {}
    virtual ~XrlBcastV1p0Client() {}

    typedef XorpCallback1<void, const XrlError&>::RefPtr SetHelloIntervalCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Set HELLO interval (in seconds)
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param new_int new HELLO interval
     */
    bool send_set_hello_interval(
	const char*	target_name, 
	const int32_t&	new_int, 
	const SetHelloIntervalCB&	cb
    );

    typedef XorpCallback2<void, const XrlError&, const int32_t*>::RefPtr GetHelloIntervalCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Get HELLO interval
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_get_hello_interval(
	const char*	target_name, 
	const GetHelloIntervalCB&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr SetBufferSizeCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Set buffer size
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param new_buf size of packet buffer
     */
    bool send_set_buffer_size(
	const char*	target_name, 
	const int32_t&	new_buf, 
	const SetBufferSizeCB&	cb
    );

    typedef XorpCallback2<void, const XrlError&, const int32_t*>::RefPtr GetBufferSizeCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Get buffer size
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_get_buffer_size(
	const char*	target_name, 
	const GetBufferSizeCB&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr SetReliabilityCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Set RELIABILITY (TRUE or FALSE)
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param reliability set reliablity level for BCAST
     */
    bool send_set_reliability(
	const char*	target_name, 
	const bool&	reliability, 
	const SetReliabilityCB&	cb
    );

    typedef XorpCallback2<void, const XrlError&, const bool*>::RefPtr GetReliabilityCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Get RELIABILITY setting (TRUE or FALSE)
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_get_reliability(
	const char*	target_name, 
	const GetReliabilityCB&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr SetInterfaceCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Set interface over which BCAST operates
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param intf set interface over which BCAST operates
     */
    bool send_set_interface(
	const char*	target_name, 
	const string&	intf, 
	const SetInterfaceCB&	cb
    );

    typedef XorpCallback2<void, const XrlError&, const string*>::RefPtr GetInterfaceCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Get interface over which BCAST operates
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_get_interface(
	const char*	target_name, 
	const GetInterfaceCB&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr ActivateBcastCB;
    /**
     *  Send Xrl intended to:
     *  
     *  Activate the protocol
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_activate_bcast(
	const char*	target_name, 
	const ActivateBcastCB&	cb
    );

protected:
    XrlSender* _sender;

private:
    void unmarshall_set_hello_interval(
	const XrlError&	e, 
	XrlArgs*	a, 
	SetHelloIntervalCB		cb
    );

    void unmarshall_get_hello_interval(
	const XrlError&	e, 
	XrlArgs*	a, 
	GetHelloIntervalCB		cb
    );

    void unmarshall_set_buffer_size(
	const XrlError&	e, 
	XrlArgs*	a, 
	SetBufferSizeCB		cb
    );

    void unmarshall_get_buffer_size(
	const XrlError&	e, 
	XrlArgs*	a, 
	GetBufferSizeCB		cb
    );

    void unmarshall_set_reliability(
	const XrlError&	e, 
	XrlArgs*	a, 
	SetReliabilityCB		cb
    );

    void unmarshall_get_reliability(
	const XrlError&	e, 
	XrlArgs*	a, 
	GetReliabilityCB		cb
    );

    void unmarshall_set_interface(
	const XrlError&	e, 
	XrlArgs*	a, 
	SetInterfaceCB		cb
    );

    void unmarshall_get_interface(
	const XrlError&	e, 
	XrlArgs*	a, 
	GetInterfaceCB		cb
    );

    void unmarshall_activate_bcast(
	const XrlError&	e, 
	XrlArgs*	a, 
	ActivateBcastCB		cb
    );

};

#endif /* __XRL_INTERFACES_BCAST_XIF_HH__ */
